''
''2016
''Jaime Montenegro
''
''

CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  i2cclkpin = 6
  i2cdatpin = 7
  baudrate  = 57_600 
VAR
  long stack[100]
OBJ
   
  pst           : "Parallax Serial Terminal"
  rtc           : "DSRTC_driver"
 
PUB Main  | index, cogmeter[2]
                      
    pst.Start(baudrate)
    rtc.rtcEngineStart(i2cdatpin, i2cclkpin, -1)
    pst.Clear

    repeat index from 0 to 1              ''index will be used to enter meter initial values
       pst.Str(String("Enter meter "))       ''and also for pin assignment in the board
       pst.Dec(index + 1)                    ''(passing index as parameter in pulsedet function) 
       pst.Str(String(" initial reading: "))
       cogmeter[index] := pst.DecIn
       pst.NewLine
       cognew (pulsedet(index, cogmeter[index]), @stack[index * 50])
    

PUB pulsedet (optin,pulcnt)  | time 

    
    dira[optin]~
        
    repeat
       
       if ina[optin] == 1
          
          time := deltat(optin)
             if time > 2_000_000
                rtc.readClock
                pulcnt ++
                pst.Str(String("Current meter reading: "))
                pst.Dec(pulcnt)
                pst.Str(String("  "))
                DispTime
                pst.Str(String(" from pin: "))
                pst.Dec(optin)
                pst.Str(String(" meter ID: "))
                pst.Dec(optin + 1)
                pst.Newline
       waitcnt(clkfreq / 20 + cnt)
    
PUB DispTime  | Month, Date, Year, DOW, Hour, Minute, Seconds, AMPM

  Month := rtc.clockMonth
  pst.Dec(Month)
  pst.Str(String("/"))

  Date := rtc.clockDate
  pst.Dec(Date)
  pst.Str(String("/"))

  Year := rtc.clockYear
  pst.Dec(Year)
  pst.Str(String(" "))

  DOW := rtc.clockDOW
  pst.Str(DOW)
  pst.Str(String(" "))
  
  Hour := rtc.clockHour
  pst.Dec(Hour)
  pst.Str(String(":"))

  Minute := rtc.clockMinute
  pst.Dec(Minute)
  pst.Str(String(":"))
  
  Seconds := rtc.clockSecond
  pst.Dec(Seconds)
  pst.Str(String(" "))

  AMPM := rtc.clockAMPM
  if(rtc.clockAMPM == 1)
    pst.Str(string("PM"))            
  else
    pst.Str(string("AM"))
  

PUB deltat(pin) : delta | time1, time2

    ''repeat until ina[pin] == 1
    time1 := cnt
    repeat until ina[pin] == 0
    time2 := cnt
    delta := time2 - time1